from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Boolean, Int, String

Get_Empirical_Dist_R_V0_1_0 = CommandToolBuilder(tool="get_empirical_dist.R", base_command=["get_empirical_dist.R"], inputs=[ToolInput(tag="in_input_ref_file", input_type=File(optional=True), prefix="--input-ref-file", doc=InputDocumentation(doc="Path to file with reference cell types")), ToolInput(tag="in_exclusions", input_type=File(optional=True), prefix="--exclusions", doc=InputDocumentation(doc="Path to the yaml file with excluded terms.\nMust contain fields 'unlabelled' and 'trivial_terms'")), ToolInput(tag="in_label_column_ref", input_type=File(optional=True), prefix="--label-column-ref", doc=InputDocumentation(doc="Name of the label column in reference file")), ToolInput(tag="in_lab_cl_mapping", input_type=File(optional=True), prefix="--lab-cl-mapping", doc=InputDocumentation(doc="Path to serialised object containing cell label to CL terms mapping")), ToolInput(tag="in_parallel", input_type=Boolean(optional=True), prefix="--parallel", doc=InputDocumentation(doc="Boolean: Should computation be run in parallel? Default: FALSE")), ToolInput(tag="in_num_iterations", input_type=Int(optional=True), prefix="--num-iterations", doc=InputDocumentation(doc="Number of sampling iterations to construct empirical distribution")), ToolInput(tag="in_sample_labs", input_type=Int(optional=True), prefix="--sample-labs", doc=InputDocumentation(doc="Labels sample size to infer the distribution from.")), ToolInput(tag="in_num_cores", input_type=Int(optional=True), prefix="--num-cores", doc=InputDocumentation(doc="Number of cores to run the process on. Default: all available cores. --parallel must be set to 'true' for this to take effect")), ToolInput(tag="in_tmpdir", input_type=File(optional=True), prefix="--tmpdir", doc=InputDocumentation(doc="Cache directory path")), ToolInput(tag="in_ontology_graph", input_type=File(optional=True), prefix="--ontology-graph", doc=InputDocumentation(doc="Path to the ontology graph in .obo or .xml format.\nImport link can also be provided.")), ToolInput(tag="in_semantic_sim_metric", input_type=String(optional=True), prefix="--semantic-sim-metric", doc=InputDocumentation(doc="Semantic similarity scoring method. Must be supported by\nOnassis package. See listSimilarities()$pairwiseMeasures\nfor a list of accepted options. Obviously must correspond\nto similarity metric used in other scripts.")), ToolInput(tag="in_output_path", input_type=File(optional=True), prefix="--output-path", doc=InputDocumentation(doc="Path to the output CDF list object in .rds format"))], outputs=[ToolOutput(tag="out_output_path", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_path", type_hint=File()), doc=OutputDocumentation(doc="Path to the output CDF list object in .rds format"))], container="quay.io/biocontainers/cell-types-analysis:0.1.11--0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Get_Empirical_Dist_R_V0_1_0().translate("wdl")

